% This is a Matlab script. This script reads file
% Association_eddies_max.mat. It converts to Matlab v6 format some
% output of TOEddies: id_child, which is necessary for the script
% overlap_v6.py.

clear
disp('Loading Association_eddies_max...')
tic
load('Association_eddies_max.mat', 'id_child')
toc
disp('Saving id_child...')
n_dates = size(id_child, 2)
n_files = 10;
chunck = ceil(n_dates / n_files);
last_date = 0;
tic

for i = 0:n_files - 2
    first_date = last_date + 1;
    last_date = last_date + chunck
    part_id_child = id_child(:, first_date:last_date);
    destination = strcat('id_child_', int2str(i));
    save(destination, 'part_id_child', '-v6')
end

first_date = last_date + 1;
part_id_child = id_child(:, first_date:end);
destination = strcat('id_child_', int2str(n_files - 1));
save(destination, 'part_id_child', '-v6')
toc
exit
