#!/usr/bin/env python3

import filter
import functools
import shutil
from os import path
import sys

def in_date_range(shape_rec_extr, shape_rec_outer, shape_rec_max, date_1):
    return date_1 <= shape_rec_extr.record.date <= date_1 + 4

if len(sys.argv) != 2: sys.exit("Required argument: SHPC-directory")
my_dir = path.join(sys.argv[1], "Slice_0/Anticyclones")

for n in range(3):
    date_1 = 20454 + n * 5
    accept = functools.partial(in_date_range, date_1 = date_1)
    filter.filter(my_dir, f"SHPC/Slice_{n}/Anticyclones", accept_func= accept)

with open("SHPC/n_slices.txt", "w") as f: f.write("3\n")
fname = path.join(sys.argv[1], "grid_nml.txt")
shutil.copy2(fname, "SHPC")
