module copy_shift_m

  implicit none

contains

  function copy_shift(p, delta_long)

    ! Libraries:
    use contour_531, only: polyline
    use jumble, only: twopi

    type(polyline), intent(in):: p
    real, intent(in):: delta_long ! difference in longitude, in rad
    type(polyline) copy_shift

    !------------------------------------------------------------------

    copy_shift%n_points = p%n_points
    copy_shift%closed = p%closed
    allocate(copy_shift%points(2, p%n_points))
    copy_shift%points(2, :) = p%points(2, :)

    ! Shift the longitudes of `p`:
    copy_shift%points(1, :) = p%points(1, :) &
         + floor(delta_long / twopi + 0.5) * twopi

  end function copy_shift

end module copy_shift_m
