module dispatch_snapshot_m

  implicit none

contains

  subroutine dispatch_snapshot(s, unit_isolated, rank, k_begin, k)

    use config_graph_m, only: max_delta
    use derived_types, only: snapshot
    use send_snapshot_m, only: send_snapshot

    type(snapshot), intent(in):: s

    integer, intent(in):: unit_isolated
    ! logical unit for file isolated_nodes_$rank.csv

    integer, intent(in):: rank, k_begin
    integer, intent(in):: k ! date index

    ! Local:
    integer i

    !------------------------------------------------------------------

    if (rank == 0 .or. k >= k_begin + max_delta) then
       do i = 1, s%number_extr
          if (s%list(i)%delta_in == huge(0) &
               .and. s%list(i)%delta_out == huge(0)) &
               write(unit_isolated, fmt = *) k, i
       end do
    else
       call send_snapshot(s, tag = k, dest = rank - 1)
    end if

  end subroutine dispatch_snapshot

end module dispatch_snapshot_m
